import json

from osgeo import gdal

from PkkInfo.ui.tools.gdalRaster import RasterGdal
from PkkInfo.ui.tools.pkkTools import PkkImage

str_jsonobj='{"features": [{"type": 1, "sort": 7701000501204884, "attrs": {"address": "ример", "category_type": "003002000000", "cn": "77:01:0005012:4884", "id": "77:1:5012:4884"}, "extent": {"xmax": 4184222.7395055704, "ymax": 7505094.447297374, "xmin": 4183433.2057920494, "ymin": 7504478.969071752}, "center": {"x": 4183782.965074744, "y": 7504763.658207147}}], "total_relation": "eq", "total": 1}'
str_jsonobj='{"total_relation": "eq", "total": 1, "features": [{"extent": {"xmax": 4210016.08384961, "ymin": 7505780.5308968155, "ymax": 7505934.052559737, "xmin": 4209888.66184744}, "sort": 7703000700200039, "attrs": {"address": "\u0433 \u041c\u043e\u0441\u043a\u0432\u0430, \u0443\u043b \u0412\u0435\u0448\u043d\u044f\u043a\u043e\u0432\u0441\u043a\u0430\u044f, \u0432\u043b 4\u0410", "category_type": "003002000000", "cn": "77:03:0007002:39", "id": "77:3:7002:39"}, "center": {"x": 4209968.254779714, "y": 7505853.552966061}, "type": 1}]}'
js_obj= json.loads(str_jsonobj)
base_url='https://pkk.rosreestr.ru/arcgis/rest/services/PKK6/CadastreSelected/MapServer/export'
pkk_image=PkkImage(base_url)
obj_image,param_image=pkk_image.getImage(js_obj['features'][0])
if obj_image is not None:
    path_raster=f"e:/tmp/test_pkk_7701000501204884_raster.png"
    #gdal.FileFromMemBuffer(path_raster,obj_image)
    '''
    with open( path_raster, "wb") as binary_file:


        binary_file.write(obj_image)
    '''
    path_out=f"e:/tmp/test_pkk_7703000700200039.shp"
    pkk_rastre=RasterGdal()
    pkk_rastre.createImage(param_image,obj_image)
    path_out_raster=f"e:/tmp/test_pkk_7703000700200039.png"
    pkk_rastre.saveImageToFile(obj_image,path_out_raster)
    resolution=param_image['bound'].Width/param_image['width']
    pkk_rastre.createVectort(resolution*1.4,path_out)
print("End")
