import axipy
from axipy import AxiomaPlugin

from PkkInfo.ui.PkkFIndLand import PkkFindLand
from PkkInfo.ui.PkkInfoFromMap import PkkInfoMap
from PkkInfo.ui.docWidget import DelDocWidget


class Plugin(AxiomaPlugin):
    def load(self):
        self.__list_cls_action=[]
        self.__observer_data_catalog=None
        self.__cls_pkk_find=PkkFindLand(self)
        if self.__cls_pkk_find is not None:
            self.__list_cls_action.append(self.__cls_pkk_find)

        cls__pkk_map_info=PkkInfoMap(self)
        self.__list_cls_action.append(cls__pkk_map_info)

        position = self.get_position('ПКК', 'Инструменты')
        for cls_action in self.__list_cls_action:

            position.add(cls_action.action,size=2)
    def getPkkFindLand(self):
        return self.__cls_pkk_find
    def unload(self):
        #self.__action.remove()
        if len(self.__list_cls_action)>0:
            for cls in self.__list_cls_action:
                doc_widget=cls.docWidget
                self.__removeWidget(doc_widget)
    def __removeWidget(self,doc):
        if doc is None:
            return
        DelDocWidget(axipy.app.mainwindow.qt_object(),doc)
        doc=None