import axipy
from axipy import state_manager, MapView


def isMapPkk(map):
    try:
        for layer in map.layers:
            table=layer.data_object
            if (table.name=='CadastreObjects' and table.provider=='RestDataProvider') or (table.name=='cadastre' and table.provider=='TmsDataProvider'):
                return True
            if (table.name=='CadastreObjectsBuilds' and table.provider=='RestDataProvider') or (table.name=='CadastreSplit' and table.provider=='TmsDataProvider'):
                return True
    except:
        pass
    return False

def factoryObserverPkkMap(name_observer):
    observer=None
    try:
        observer=state_manager.find(name_observer)
    except:
        pass
    if observer is None:
        observer=state_manager.create(name_observer,False)
        def change_count_map():
            list_map=axipy.gui.view_manager.mapviews
            if list_map is None or len(list_map)==0:
                observer.setValue(False)
                return
            for map_view in list_map:
                isPkkMap=isMapPkk(map_view.map)
                if isPkkMap:
                    observer.setValue(True)
                return
            observer.setValue(False)
            return

        def changeActiveView():
            acitive_view =axipy.gui.view_manager.active
            if not isinstance(acitive_view,MapView):

                observer.setValue(False)
                return
            isPkkMap=isMapPkk(acitive_view.map)
            if isPkkMap:
                observer.setValue(True)
                return
            observer.setValue(False)
            return

        def addChildrenWidget(name_tool,widget):
            observer.children_widgets[name_tool]=widget
        def removeChildrenWidget(name):
            try:
                del observer.children_widgets[name]
            except:
                pass

        setattr(observer, "children_widgets", {})
        setattr(observer, "changeActiveView", changeActiveView)

        setattr(observer, "addChildrenWidget", addChildrenWidget)
        setattr(observer, "removeChildrenWidget", removeChildrenWidget)
        axipy.gui.view_manager. active_changed.connect(observer.changeActiveView)

    return observer